# MongoDB database plugin HTTP API

The MongoDB database plugin is one of the supported plugins for the database secrets engine. This plugin generates database credentials dynamically based on configured roles for the MongoDB database.

### Configure connection <a href="#configure-connection" id="configure-connection"></a>

In addition to the parameters defined by the Database Backend, this plugin has a number of parameters to further configure a connection.

| Method | Path                     |
| ------ | ------------------------ |
| `POST` | `/database/config/:name` |

#### Parameters <a href="#parameters" id="parameters"></a>

* `connection_url` `(string: <required>)` – Specifies the MongoDB standard connection string (URI). This field can be templated and supports passing the username and password parameters in the following format {{field\_name}}. A templated connection URL is required when using root credential rotation.
* `write_concern` `(string: "")` - Specifies the MongoDB write concern. This is set for the entirety of the session, maintained for the lifecycle of the plugin process. Must be a serialized JSON object, or a base64-encoded serialized JSON object. The JSON payload values map to the values in the Safe struct from the mgo driver.
* `username` `(string: "")` - The root credential username used in the connection URL.
* `password` `(string: "")` - The root credential password used in the connection URL.
* `tls_certificate_key` `(string: "")` - x509 certificate for connecting to the database. This must be a PEM encoded version of the private key and the certificate combined.
* `tls_ca` `(string: "")` - x509 CA file for validating the certificate presented by the MongoDB server. Must be PEM encoded.
* `username_template` `(string)` - Template describing how dynamic usernames are generated.

<details>

<summary>Default Username Template</summary>

```mdx-code-blocks_codeBlockMargin__TI7B4
{{ printf "v-%s-%s-%s-%s" (.DisplayName | truncate 15) (.RoleName | truncate 15) (random 20) (unix_time) | replace "." "-"  | truncate 100 }}
```

</details>

#### Sample payload <a href="#sample-payload" id="sample-payload"></a>

```json
{
  "plugin_name": "mongodb-database-plugin",
  "allowed_roles": "readonly",
  "connection_url": "mongodb://{{username}}:{{password}}@mongodb.acme.com:27017/admin?ssl=true",
  "write_concern": "{ \"wmode\": \"majority\", \"wtimeout\": 5000 }",
  "username": "admin",
  "password": "Password!"
}
```

#### Sample request <a href="#sample-request" id="sample-request"></a>

```shell-session
$ curl \
    --header "X-Vault-Token: ..." \
    --request POST \
    --data @payload.json \
    http://127.0.0.1:8200/v1/database/config/mongodb
```

### Statements <a href="#statements" id="statements"></a>

Statements are configured during role creation and are used by the plugin to determine what is sent to the database on user creation, renewing, and revocation. For more information on configuring roles see the Role API in the database secrets engine docs.

#### Parameters <a href="#parameters-1" id="parameters-1"></a>

The following are the statements used by this plugin. If not mentioned in this list the plugin does not support that statement type.

* `creation_statements` `(string: <required>)` – Specifies the database statements executed to create and configure a user. Must be a serialized JSON object, or a base64-encoded serialized JSON object. The object can optionally contain a `db` string for session connection, and must contain a `roles` array. This array contains objects that holds a `role`, and an optional `db` value, and is similar to the BSON document that is accepted by MongoDB's `roles` field. Vault will transform this array into such format. For more information regarding the `roles` field, refer to MongoDB's documentation.
* `revocation_statements` `(string: "")` – Specifies the database statements to be executed to revoke a user. Must be a serialized JSON object, or a base64-encoded serialized JSON object. The object can optionally contain a `db` string. If no `db` value is provided, it defaults to the `admin` database.

#### Sample creation statement <a href="#sample-creation-statement" id="sample-creation-statement"></a>

```json
{
  "db": "admin",
  "roles": [
    {
      "role": "read",
      "db": "foo"
    }
  ]
}
```

#### Sample revocation statement <a href="#sample-revocation-statement" id="sample-revocation-statement"></a>

```json
{
  "db": "vault-db"
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.enclaive.cloud/vault/api/secrets-engines/database/mongodb-database-plugin-http-api.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
